unit M24sm;

{Naprogramoval cislo 24, Hradec Kralove 1. - 3. cervna 2001}
{program vyzaduje vsechny soubory s priponou pas v adresari soutez.}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, Grids, ComCtrls, ToolWin, ImgList, Spin, ExtCtrls;

type
  PPlayer = ^TPlayer;
  TPlayer = object
    Name:string;
    Body:integer;
    Znacka:char;
    barva:tcolor;
  end;
  TFMain = class(TForm)
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Novhra1: TMenuItem;
    Konec1: TMenuItem;
    N1: TMenuItem;
    SGrid1: TStringGrid;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    LNamematch: TLabel;
    LName1: TLabel;
    LName2: TLabel;
    ImageList1: TImageList;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Pomcky1: TMenuItem;
    Npovdanadaltah1: TMenuItem;
    UkzkaPCprotiPC1: TMenuItem;
    N2: TMenuItem;
    Desetnejlepch1: TMenuItem;
    Provstdaltah1: TMenuItem;
    Label6: TLabel;
    SpinEdit1: TSpinEdit;
    Label7: TLabel;
    Timer1: TTimer;
    ToolButton3: TToolButton;
    procedure Konec1Click(Sender: TObject);
    procedure Novhra1Click(Sender: TObject);
    procedure SGrid1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure SGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure Desetnejlepch1Click(Sender: TObject);
    procedure Npovdanadaltah1Click(Sender: TObject);
    procedure Provstdaltah1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure UkzkaPCprotiPC1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Hrac1,Hrac2,Hrac:PPlayer;
    TopTen:TStrings;
    modhry:integer;
    procedure nextplayer;
    procedure vypis;
    procedure pridejtopten(pl:PPlayer);
    procedure napoveda(var x,y:integer);
    procedure zablikej(x,y:integer);
    function lzehrat:boolean;
    function indexpole(x,y:integer):integer;
  end;

var
  FMain: TFMain;

implementation

uses M24new, M24kon;

function oddel(retez:string;number:integer):string;
var
  i,j:integer;
  piece:string;
begin
  retez:=retez+';';
  j:=1;
  piece:='';
  for i:=1 to length(retez) do begin
    if j=number then piece:=piece+retez[i];
    if retez[i]=';' then inc(j);
  end;
  result:=copy(piece,1,length(piece)-1);
end;

function oddel1(retez:string;number:integer;oddelovac:char):string;
var
  i,j:integer;
  piece:string;
begin
  retez:=retez+oddelovac;
  j:=1;
  piece:='';
  for i:=1 to length(retez) do begin
    if j=number then piece:=piece+retez[i];
    if retez[i]=oddelovac then inc(j);
  end;
  result:=copy(piece,1,length(piece)-1);
end;

{$R *.DFM}

{ TForm1 }


procedure TFMain.Konec1Click(Sender: TObject);
begin
  close;
end;

procedure TFMain.nextplayer;
var
  ch:char;
begin
  if hrac=nil then exit;
  ch:=hrac.Znacka;
  case ch of
    'A' : begin
        hrac:=hrac2;
      end;
    'B' : begin
        hrac:=hrac1;
      end;
  end;
  LNamematch.Caption:=hrac.Name;
  Label4.caption:=IntToStr(hrac1.body);
  Label5.caption:=IntToStr(hrac2.body);

  if not lzehrat then begin
    if hrac1.Body>hrac2.body then hrac:=hrac1;
    if hrac1.Body<hrac2.body then hrac:=hrac2;
    if hrac1.Body=hrac2.body then begin {maji stejne bodu !!!}
      hrac:=nil;
      FKonec.Label2.Caption:='Nerozhodne';
      FKonec.Label4.Caption:='';
      FKonec.Label6.Caption:=IntToStr(hrac1.body);
      pridejtopten(hrac1);
      pridejtopten(hrac2);
    end;
    if hrac<>nil then begin
      FKonec.Label2.Caption:='Vyhrl hr:';
      FKonec.Label4.Caption:=hrac.Name;
      FKonec.Label6.Caption:=IntToStr(hrac.body);
      pridejtopten(hrac);
    end;
    FKonec.GroupBox1.BringToFront;
    hrac:=nil;
    FKonec.showmodal;
  end;
  if hrac<>nil then
  if hrac.Name='Pota' then timer1.enabled:=True;
end;

procedure TFMain.Novhra1Click(Sender: TObject);
begin
  FNew.showmodal;
end;

procedure TFMain.SGrid1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  ACol,ARow:integer;
  i:integer;
begin
  if hrac=nil then exit;
  Sgrid1.MouseToCell(x,y,ACol,ARow);
  if (acol<0) or (arow<0) then exit;
  try
    i:=StrtoInt(Sgrid1.Cells[acol,arow]);
  except
    i:=0;
  end;
  if i<>4 then inc(i); {nelze pridat, kdyz uz jsou ctyri}
  Sgrid1.Cells[acol,arow]:=IntToStr(i);
  if i=4 then begin
    Hrac^.Body:=Hrac^.body+1;
    Sgrid1.Cells[acol,arow]:=Hrac^.znacka;
  end;
  Nextplayer;
end;

procedure TFMain.FormCreate(Sender: TObject);
var
  i:integer;
begin
  new(hrac1);
  hrac1^.Znacka:='A';
  new(hrac2);
  hrac2^.Znacka:='B';
  TopTen:=TStringlist.create;
  try
    TopTen.LoadFromFile('topten.txt');
  except
    for i:=1 to 10 do topten.Add(';0;');
  end;
end;

procedure TFMain.FormDestroy(Sender: TObject);
begin
  dispose(hrac1);
  dispose(hrac2);
end;

procedure TFMain.SGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  c:integer;
begin
  c:=16;
  Sgrid1.Canvas.Brush.Color := clwhite;
  SGrid1.Canvas.FillRect(Rect);
  if SGrid1.cells[acol,arow]='1' then Imagelist1.Draw(SGrid1.canvas,rect.Left,rect.Top,0);
  if SGrid1.cells[acol,arow]='2' then begin
    Imagelist1.Draw(SGrid1.canvas,rect.Left,rect.Top,0);
    Imagelist1.Draw(SGrid1.canvas,rect.Left+c,rect.Top,0);
  end;
  if SGrid1.cells[acol,arow]='3' then begin
    Imagelist1.Draw(SGrid1.canvas,rect.Left,rect.Top,0);
    Imagelist1.Draw(SGrid1.canvas,rect.Left+c,rect.Top,0);
    Imagelist1.Draw(SGrid1.canvas,rect.Left,rect.Top+c,0);
  end;
  if SGrid1.cells[acol,arow]='A' then begin {Ma hrac A}
    Imagelist1.Draw(SGrid1.canvas,rect.Left,rect.Top,2);
    Imagelist1.Draw(SGrid1.canvas,rect.Left+c,rect.Top,2);
    Imagelist1.Draw(SGrid1.canvas,rect.Left,rect.Top+c,2);
    Imagelist1.Draw(SGrid1.canvas,rect.Left+c,rect.Top+c,2);
  end;
  if SGrid1.cells[acol,arow]='B' then begin {Ma hrac B}
    Imagelist1.Draw(SGrid1.canvas,rect.Left,rect.Top,3);
    Imagelist1.Draw(SGrid1.canvas,rect.Left+c,rect.Top,3);
    Imagelist1.Draw(SGrid1.canvas,rect.Left,rect.Top+c,3);
    Imagelist1.Draw(SGrid1.canvas,rect.Left+c,rect.Top+c,3);
  end;
  if SGrid1.cells[acol,arow]='C' then begin {Zablika to}
  if hrac=hrac1 then Sgrid1.Canvas.Brush.Color := hrac.barva;
  if hrac=hrac2 then Sgrid1.Canvas.Brush.Color := hrac.barva;
  SGrid1.Canvas.FillRect(Rect);
  end;
  if (gdselected in state) then begin
    Sgrid1.Canvas.DrawFocusRect(rect);
  end;
end;

procedure TFMain.SGrid1KeyPress(Sender: TObject; var Key: Char);
var
  acol,arow,i:integer;
begin
  if hrac=nil then exit;
  acol:=sgrid1.col;
  arow:=sgrid1.row;
  if key=#13 then begin
    if (acol<0) or (arow<0) then exit;
    try
      i:=StrtoInt(Sgrid1.Cells[acol,arow]);
    except
      i:=0;
    end;
    inc(i);
    Sgrid1.Cells[acol,arow]:=IntToStr(i);
    if i=4 then begin
      Hrac^.Body:=Hrac^.body+1;
      Sgrid1.Cells[acol,arow]:=Hrac^.znacka;
    end;
    Nextplayer;
  end;
end;

function TFMain.lzehrat;
var
  i,j:integer;
begin
  result:=false;
  for i:=0 to sgrid1.colcount-1 do
  for j:=0 to sgrid1.rowcount-1 do
  if (sgrid1.cells[i,j]<>'A') and (sgrid1.cells[i,j]<>'B') then result:=true;

end;

procedure TFMain.pridejtopten;
var
  i:integer;
begin
  for i:=0 to topten.count-1 do begin
    if StrToInt(oddel((topten.strings[i]),2))<pl.Body then begin
      topten.Insert(i,pl.name+';'+IntToStr(pl.body)+';');
      break;
    end;
  end;
  topten.SaveToFile('topten.txt');
  vypis;
end;

procedure TFMain.vypis;
var
  i:integer;
begin
  FKonec.StringGrid1.Cells[0,0]:='Jmno';
  FKonec.StringGrid1.Cells[1,0]:='Body';
  for i:=1 to 11 do begin
    try
    FKonec.StringGrid1.Cells[0,i]:=oddel(topten.strings[i-1],1);
    FKonec.StringGrid1.Cells[1,i]:=oddel(topten.strings[i-1],2);
    except
    end;
  end;
end;

procedure TFMain.Desetnejlepch1Click(Sender: TObject);
begin
  FKonec.GroupBox2.BringToFront;
  FKonec.showmodal;
end;

procedure TFMain.napoveda(var x, y: integer);
var
  i,j,Ax,Ay,Bx,By:integer;
  je3,je2,je1,jenic:boolean;
  jenici,je1i,index:integer; {indexy poli}
begin
  x:=-1;
  y:=-1;
  je3:=false;
  je1:=false;
  je2:=false;
  jenic:=false;
  jenici:=0;
  je1i:=0;
  ax:=0;
  ay:=0;
  bx:=0;
  by:=0;
  for i:=0 to sgrid1.colcount-1 do
  for j:=0 to sgrid1.rowcount-1 do begin
    if sgrid1.cells[i,j]='3' then begin {toto je urcite bod }
      x:=i;
      y:=j;
      je3:=true;
    end;
    if (sgrid1.cells[i,j]='1') and not je3 then begin {jednicka je taky bezpecna}
      if je1 then begin
        index:=indexpole(i,j); {Jakou ma pole vahu pro vyber tahu}
      end else index:=20;
      if index>je1i then begin
        x:=i;
        y:=j;
        if index<>20 then je1i:=index;
      end;
      je1:=true;
    end;
    if sgrid1.cells[i,j]='2' then begin {jen v nejhorsim pripade zvysovat na tri sirky}
      Bx:=i;
      By:=j;
      je2:=true;
    end;
    if (sgrid1.cells[i,j]='0') or (sgrid1.cells[i,j]='') then begin {prazdne pole}
      if jenic then begin
        index:=indexpole(i,j); {Jakou ma pole vahu pro vyber tahu}
      end else index:=20;
      if index>jenici then begin
        Ax:=i;
        Ay:=j;
        if index<>20 then jenici:=index;
      end;
      jenic:=true;
    end;
    if je3 then break;
  end;
  if (not je3) then begin
    if jenic and not je1 then begin {kdyz je nejake pole volne a zaroven tam nekde neni uz jen jedna sirka}
      x:=ax;
      y:=ay;
    end;
    if ((not jenic) and je2) and not je1 then begin {vypada to spatne, vracim prohravajici pozici}
      x:=Bx;
      y:=By;
    end;
  end;
  if x=-1 then begin {kdyz nenaslo zadny tah, vracim jakykoli mozny. Tato moznost by nemela nastat, ale projistotu, aby nezstal PC bez tahu}
    for i:=0 to sgrid1.colcount-1 do
    for j:=0 to sgrid1.rowcount-1 do begin
      if (sgrid1.cells[i,j]<>'A') and (sgrid1.cells[i,j]<>'B') then begin
        x:=i;
        y:=j;
      end;
    end;
  end;
end;

procedure TFMain.Npovdanadaltah1Click(Sender: TObject);
var
  x,y:integer;
begin
  napoveda(x,y);
  zablikej(x,y);
end;

procedure TFMain.zablikej;
var
  pom:string;
  i:integer;
begin
  if (x=-1) or (y=-1) then exit;
  pom:=sgrid1.cells[x,y];
  for i:=1 to 2 do begin
    sgrid1.cells[x,y]:='C';
    sgrid1.Refresh;
    Application.ProcessMessages;
    sleep(200);
    Application.ProcessMessages;
    sgrid1.cells[x,y]:=pom;
    sgrid1.Refresh;
    Application.ProcessMessages;
    sleep(200);
    Application.ProcessMessages;
  end;
end;

procedure TFMain.Provstdaltah1Click(Sender: TObject);
var
  x,y:integer;
  acol,arow,i:integer;
begin
  napoveda(x,y);
{  zablikej(x,y);}
  if hrac=nil then exit;
  acol:=x;
  arow:=y;
  if (acol<0) or (arow<0) then exit;
  try
    i:=StrtoInt(Sgrid1.Cells[acol,arow]);
  except
    i:=0;
  end;
  inc(i);
  Sgrid1.Cells[acol,arow]:=IntToStr(i);
  if i=4 then begin
    Hrac^.Body:=Hrac^.body+1;
    Sgrid1.Cells[acol,arow]:=Hrac^.znacka;
  end;
  Nextplayer;
end;

procedure TFMain.SpinEdit1Change(Sender: TObject);
begin
  try
    Timer1.Interval:=SpinEdit1.Value;
  except
  end;
end;

procedure TFMain.Timer1Timer(Sender: TObject);
begin
  timer1.Enabled:=False;
  if lzehrat then Provstdaltah1Click(self);
end;

procedure TFMain.UkzkaPCprotiPC1Click(Sender: TObject);
begin
  FNew.ComboBox2.itemindex:=3;
  FNew.ComboBox2Change(self);
  FNew.ComboBox1.itemindex:=8;
  FNew.ButtonOKclick(self);
end;

function TFMain.indexpole(x, y: integer): integer; {spocita hodnotu pole. Zpusobi to, ze program nezacina davat tahy od praveho
                                                   spodniho rohu, ale odprostred}
begin
  if x>(sgrid1.colcount div 2) then x:=sgrid1.colcount-x;
  if y>(sgrid1.rowcount div 2) then y:=sgrid1.rowcount-y;
  result:=x+y;
end;

end.
